

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


@SuppressWarnings("serial")
public class VerificarCidadesDoEstadoServlet extends HttpServlet {

	private Map<String,String[]> cidadesDosEstados = new HashMap<String, String[]>();
	
	public VerificarCidadesDoEstadoServlet() {
		cidadesDosEstados.put("SP", new String[]{"So Paulo","Campinas","Santos"});
		cidadesDosEstados.put("SC", new String[]{"Florianopolis","Blumenau"});
	}
	
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String estadoSelecionado = request.getParameter("estadoSelecionado");		
		
		String[] cidades = cidadesDosEstados.get(estadoSelecionado);
		
		
		
		String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
				"<cidades>";
		if(cidades != null){
			for (String cidade : cidades) {
				xml = xml + "<cidade>" + cidade + "</cidade>";
			}
		}
		xml = xml + "</cidades>";
		
		response.setContentType("text/xml");
		response.getWriter().println(xml);
	}


}
