package br.usp.ime.exemplos.model;

import java.util.ArrayList;
import java.util.List;

public class GerenciadorDeNoticias {
	
	private static GerenciadorDeNoticias instancia = new GerenciadorDeNoticias();	
	
	private List<Noticia> noticiasDoSite = new ArrayList<Noticia>();
	
	public synchronized void adicionaNoticia(Noticia noticia){
		this.noticiasDoSite.add(noticia);
		this.notifyAll();
	}
	
	private synchronized List<Noticia> pegaNoticiasMaisNovas(Noticia ultimaNoticiaVista){
		if(ultimaNoticiaVista == null)
			return noticiasDoSite;
		List<Noticia> noticiasMaisNovas = new ArrayList<Noticia>();
		for (Noticia noticiaAtual : noticiasDoSite) {
			if(noticiaAtual.ehMaisNova(ultimaNoticiaVista))
				noticiasMaisNovas.add(noticiaAtual);				
		}
		return noticiasMaisNovas;
	}	
	
	public synchronized List<Noticia> pegaEEsperaPorNoticiasMaisNovas(Noticia ultimaNoticiaVista){
		List<Noticia> noticiasMaisNovas;
		while(true){
			noticiasMaisNovas = pegaNoticiasMaisNovas(ultimaNoticiaVista);
			if(noticiasMaisNovas.size() > 0)
				break;
			try {
				this.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}		
		return noticiasMaisNovas;
	}
	
	public static GerenciadorDeNoticias getInstancia(){
		return instancia;
	}
	
	
}
