package br.usp.ime.exemplos.model;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class Noticia {

	private String mensagem;
	private Calendar dataHoraInformada;
	
	public Noticia(String mensagem) {
		this.mensagem = mensagem;
		this.dataHoraInformada = Calendar.getInstance();
	}

	public boolean ehMaisNova(Noticia ultimaNoticiaVista) {
		int comparacao = dataHoraInformada.compareTo(ultimaNoticiaVista.getDataHoraInformada());
		return comparacao > 0;
	}

	public String toXML() {
		SimpleDateFormat formatador = new SimpleDateFormat("dd/MM/yyyy - HH:mm:ss");
		Date horaDate = dataHoraInformada.getTime();
		String dataHoraFormatada = formatador.format(horaDate);		
		String xml = 	"<noticia>" +
						"<mensagem>" + mensagem + "</mensagem>" + 
						"<dataHora>" + dataHoraFormatada + "</dataHora>" + 
						"</noticia>";
		return xml;
	}

	public Calendar getDataHoraInformada() {
		return dataHoraInformada;
	}

}
