package br.usp.ime.exemplos.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.exemplos.model.GerenciadorDeNoticias;
import br.usp.ime.exemplos.model.Noticia;

@SuppressWarnings("serial")
public class VerificadorDeNoticiasServlet extends HttpServlet{

	private GerenciadorDeNoticias gerenciadorDeNoticias = GerenciadorDeNoticias.getInstancia();
	
	private String delimitador = "delimitador";
	
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
			
		iniciaMultipartResponse(resp);
		
		Noticia ultimaNoticiaVista = null;
		while(true){
			List<Noticia> noticiasMaisNovas = gerenciadorDeNoticias.pegaEEsperaPorNoticiasMaisNovas(ultimaNoticiaVista);
			for (Noticia noticiaAtual : noticiasMaisNovas) {
				enviarNoticia(noticiaAtual,resp);
				ultimaNoticiaVista = noticiaAtual;
			}
		}
		
	}

	private void iniciaMultipartResponse(HttpServletResponse resp) throws IOException {
		resp.setHeader("Content-type", "multipart/x-mixed-replace;boundary=\"" + delimitador + "\"");		
		resp.getWriter().write("--" + delimitador + "\n");
	}

	private void enviarNoticia(Noticia noticia ,HttpServletResponse resp) throws IOException {
		
		PrintWriter writer = resp.getWriter();
		writer.write("Content-type: text/xml\n\n");
		writer.write("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");		
		writer.write(noticia.toXML() + "\n");		
		resp.flushBuffer();
		writer.println("--" + delimitador);
		resp.flushBuffer();
	}
	
	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doGet(req, resp);
	}
}
